package com.perforce.maven.scm.provider.p4.command.branch;

/*
 * Copyright (c) 2010 Perforce Software. All rights reserved.
 */

import org.apache.maven.scm.ScmFileSet;
import org.apache.maven.scm.tck.command.branch.BranchCommandTckTest;
import org.codehaus.plexus.util.FileUtils;
import org.codehaus.plexus.util.StringUtils;

import com.perforce.maven.scm.provider.p4.P4ScmTestUtils;
import com.perforce.maven.scm.provider.p4.util.P4ScmUrl;

public class P4BranchLogCommandTckTest
    extends BranchCommandTckTest
{

    /** {@inheritDoc} */
    public String getScmUrl()
        throws Exception
    {
        return P4ScmTestUtils.getScmUrl();
    }

    /** {@inheritDoc} */
    public void initRepo()
        throws Exception
    {
        P4ScmTestUtils.initRepo();
        resetToOrignalFiles();
    }

    protected String getBranch()
    {
        try
        {
            P4ScmUrl parser = P4ScmUrl.parse( getScmUrl() );

            String[] tokens = StringUtils.split( parser.getPath().substring( 1 ), "/" );

            StringBuffer buffer = new StringBuffer();
            buffer.append( "//" ).append( tokens[0] ).append( "/" ).append( "branches" );

            for ( int i = 1; i < tokens.length; ++i )
            {
                buffer.append( "/" ).append( tokens[i] );
            }

            buffer.append( "-" ).append( System.currentTimeMillis() );

            return buffer.toString();

        }
        catch ( Exception e )
        {
            throw new IllegalArgumentException( "Unable construction TCK SCM Url", e );
        }
    }

    private void resetToOrignalFiles()
        throws Exception
    {
        checkOut( getWorkingCopy(), getScmRepository() );
        ScmFileSet fileSet = new ScmFileSet( getWorkingCopy(), P4ScmTestUtils.getAddedIncludes(), null );
        getScmManager().getProviderByUrl( getScmUrl() ).remove( getScmRepository(), fileSet,
                                                                "Remove previous test files" );
        fileSet = new ScmFileSet( getWorkingDirectory() );
        getScmManager().getProviderByUrl( getScmUrl() ).edit( getScmRepository(), fileSet );
        P4ScmTestUtils.populateOriginalData( getBasedir(), getWorkingCopy() );
        checkIn( getWorkingCopy(), getScmRepository() );
        FileUtils.deleteDirectory( getWorkingDirectory() );
    }

}
